/**
 * Copyright (c) 2006, yher2.net
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without modification, 
 * are permitted provided that the following conditions are met:
 * 
 * * Redistributions of source code must retain the above copyright notice, 
 *   this list of conditions and the following disclaimer.
 * * Redistributions in binary form must reproduce the above copyright notice, 
 *   this list of conditions and the following disclaimer in the documentation 
 *   and/or other materials provided with the distribution.
 * * Neither the name of the nor the names of its contributors may be used to endorse or 
 *   promote products derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
 * IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY 
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF 
 * SUCH DAMAGE.
 */
package net.yher2.workstyle.torque.bean;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import net.yher2.workstyle.torque.Tag;

import org.apache.commons.lang.StringUtils;

/**
 * The skeleton for this class was autogenerated by Torque on:
 *
 * [Mon Jan 02 04:36:48 GMT+09:00 2006]
 *
 * You should add additional methods to this class to meet the
 * application requirements.  This class will only be generated as
 * long as it does not already exist in the output directory.
 */
public class TaskBean
    extends net.yher2.workstyle.torque.bean.BaseTaskBean
    implements Serializable
{
	public List<String> getTagAsList() {
		return parseTagList(getTagList());
	}
	
	public boolean hasTag(String tag) {
		return hasTag(getTagList(), tag);
	}
	
	public static boolean hasTag(String tagList, String tag) {
		return StringUtils.indexOf(tagList, Tag.format(tag)) >= 0;
	}
	
	public static List<String> parseTagList(String tagList) {
		if (StringUtils.isBlank(tagList)) return new ArrayList<String>();
		String array[] = tagList.split("[\\[\\] ]");
		List<String> result = new ArrayList<String>();
		for (String tag : array) {
			if (StringUtils.isNotBlank(tag)) {
				result.add(tag);
			}
		}
		return result;
	}
	public static String normalizeTagList(String targetTagList) {
		List<String> list = parseTagList(targetTagList);
		String result = "";
		for (String tag : list) {
			result += Tag.format(tag);
		}
		return result;
	}
}
